/********************************************************************************
    programstreamdump - dump headers of program stream packets
 ********************************************************************************
    LibVideoCoding - video coding library
    Copyright (C) 2002  Dirk Farin

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 ********************************************************************************/

#include <libvideocoding/fileio/inputstream_istr.hh>
#include <libvideocoding/mpeg2/syntax/pessource.hh>

#include <stdio.h>
#include <iostream>
#include <iomanip>
#include <fstream>
using namespace std;
using namespace videocoding;

int main(int argc,char** argv)
{
  try
    {
      InputStream_IStream istr;
      ifstream inp(argv[1]);
      istr.SetIStream(inp);

      MP2_SystemPacket* pck = NULL;

      MP2_ProgramStream_Decoder sysdec;
      sysdec.SetInputStream(istr);

      while (!sysdec.IsEOF())
	{
	  pck = sysdec.GetNextPacket();

	  if (pck)
	    {
	      cout << *pck << endl;
	      delete pck;
	    }
	  else
	    cout << "\nNULL\n\n";
	}
    }
  catch (const Excpt_Base& e)
    {
      MessageDisplay::Show(e);
    }

  return 0;
}
